# Running the Intention Progression Competition
There are 3 ways of running the Intention Progression Competition:

1. [**Docker server:**](#docker-server) the server and the bdi-interface run inside a Docker container and you run your solution locally. This is the recommended way of running it during the development/testing stages of your solution.
2. [**Docker server with Docker solution:**](#docker-server-with-docker-solution) when both the server and your solution are inside Docker containers. This is required for submission.
3. [**Local:**](#local) cloning the server and bdi-interface repositories and running everything locally. This is only recommended if you want to experiment with the source code of the server outside of the competition.

## Docker server

This assumes you have [Docker](https://www.docker.com/), Git, Gradle, and Java installed and are familiar with Git, Gradle, and Java commands. 
Steps 1 to 3 only need to be run once.
Sudo/admin rights may be required depending on how Docker was installed.   
Do not alter the Dockerfile unless you are experimenting with something. The Dockerfile of the server will be used as is (pending any bugfixes) during the competition.

1. Clone the test-agent repository: `git clone https://gitlab.com/intention-progression-competition/example-agents/test-agent.git`
2. Clone the Docker server repository: `git clone https://gitlab.com/intention-progression-competition/docker-containers/docker-ipc/docker-ipc.git` and navigate to the newly created folder
3. Build the Docker container: `docker build -t ipc-simulator .`
4. Run the container: `docker run -it --rm -p 40000:40000 -p 30000:30000 ipc-simulator bash`
5. Run the server: `java -jar simulator-server/build/libs/simulator-server-all-1.0.jar`
6. Open a new terminal and type `docker ps`
7. Copy the ID associated with the container ipc-simulator obtained from the docker ps command
8. Replace <container_id> with the ID from the previous step: `docker exec -it <container_id> bash`
9. Run the bdi-interface: `java -jar bdi-interface/build/libs/bdi-interface-all-1.0.jar`
10. Open a new terminal and navigate to the folder containing the `test-agent`
11. Compile the test agent if you have not done so yet (only needs to be done once and when the source code changes): `./gradlew jar`  
12. Run the test-agent with: `java -jar build/libs/test-agent.jar` 
13. To test, provide the first command, for example with: `<?xml version="1.0" encoding="UTF-8"?><command clientid="UONTEST1"><initiate><seed>10000</seed><gptfile>gpts/example-gpts/logistics/gpt-t5-a5-p10.xml</gptfile></initiate></command>`

You should now see the expected messages in all 3 terminals without any errors.

## Docker server with Docker solution

Note that some steps here will be replicated from the Docker server tutorial, and some may look similar but are different. If in doubt just run all of the steps from this part of the tutorial.   
Steps 1 to 7 only need to be run once (steps 5 to 7 may require repeating if you make changes to your solution).

1. Create the network the containers will use (can be done from any directory): `docker network create ipc_network`
2. Clone the Docker server repository: `git clone https://gitlab.com/intention-progression-competition/docker-containers/docker-ipc/docker-ipc.git`
3. Navigate to the `docker-ipc` folder
4. Build the Docker server container: `docker build -t ipc-simulator .`
5. Clone the Docker IPC submission example repository: `git clone https://gitlab.com/intention-progression-competition/docker-containers/docker-test-agent/docker-ipc-submission-TestAgent.git`
6. Navigate to the `docker-ipc-submission-TestAgent` folder
7. Build the Docker IPC submission container: `docker build -t ipc-submission-testagent .`
8. Navigate to the `docker-ipc` folder
9. Run the server container: `docker run -it --rm --network=ipc_network --name ipc_server ipc-simulator bash`
10. Run the server: `java -jar simulator-server/build/libs/simulator-server-all-1.0.jar`
11. Open a new terminal and type `docker ps`
12. Copy the ID associated with the container ipc-simulator obtained from the docker ps command
13. Replace <container_id> with the ID from the previous step: `docker exec -it <container_id> bash`
14. Run the bdi-interface: `java -jar bdi-interface/build/libs/bdi-interface-all-1.0.jar -C`
15. Open a new terminal and navigate to the `docker-ipc-submission-TestAgent` folder
16. Run the solution container: `docker run -it --rm --network=ipc_network ipc-submission-testagent`
17. Run the solution: `java -jar test-agent/build/libs/test-agent.jar -C`
18. To test, provide the first command, for example with: `<?xml version="1.0" encoding="UTF-8"?><command clientid="UONTEST1"><initiate><seed>10000</seed><gptfile>gpts/example-gpts/logistics/gpt-t5-a5-p10.xml</gptfile></initiate></command>`

You should now see the expected messages in all 3 terminals without any errors.

## Tutorial on how to containerise your solution

You can use the containerised version of the test-agent shown in the step above (also available here: https://gitlab.com/intention-progression-competition/docker-containers/docker-test-agent/docker-ipc-submission-TestAgent) as an example of how to setup your Dockerfile.   

## Local
This tutorial will show you how to execute the server, the bdi-interface, and the test-agent all locally.   
Steps 1 to 9 only have to be run once (you may need to update the repositories with `git pull` if there were any new changes, and rebuild the jars).
1. Create an `intention-progression-competition` folder
2. Open a terminal and navigate to that folder
3. Clone the simulator-server repository: `git clone https://gitlab.com/intention-progression-competition/simulator/simulator-server.git`
4. Clone the bdi-interface repository: `git clone https://gitlab.com/intention-progression-competition/simulator/bdi-interface.git`
5. Clone the test-agent repository: `git clone https://gitlab.com/intention-progression-competition/example-agents/test-agent.git`
6. Download the example GPTs from https://gitlab.com/intention-progression-competition/example-gpts/example-gpts/-/archive/release/example-gpts-release.zip and extract the zip file into the `intention-progression-competition` root folder
7. Navigate to `intention-progression-competition/simulator-server` and compile the jar file with: `./gradlew fatJar`
8. Navigate to `intention-progression-competition/bdi-interface` and compile the jar file with: `./gradlew fatJar`
9. Navigate to `intention-progression-competition/test-agent` and compile the jar file with: `./gradlew jar`
10. Navigate to `intention-progression-competition` folder
11. Run the simulator-server with: `java -jar simulator-server/build/libs/simulator-server-all-1.0.jar`
12. Open a new terminal and navigate to `intention-progression-competition` folder
13. Run the bdi-interface with: `java -jar bdi-interface/build/libs/bdi-interface-all-1.0.jar`
14. Open a new terminal and navigate to `intention-progression-competition` folder
15. Run the test-agent with: `java -jar test-agent/build/libs/test-agent.jar`
16. To test, provide the first command, for example with: `<?xml version="1.0" encoding="UTF-8"?><command clientid="UONTEST1"><initiate><seed>10000</seed><gptfile>example-gpts-release/logistics/gpt-t5-a5-p10.xml</gptfile></initiate></command>`

You should now see the expected messages in all 3 terminals without any errors.


### FAQ
1. How to add a custom GPT to the simulation server when running the containerised version of the server?   
A. There are two ways of doing this:
   - You can do it temporarily by adding it live in the container as you would normally in any Docker container, but it won't be there again in subsequent runs of the container
   - Or to have it permanently added to the container, assuming the name of the file is `gpt-test.xml` and it is in the same folder as Dockerfile, you can add the following commands to line 32 of Dockerfile (add more subfolders as needed):   
   `COPY gpt-test.xml /home/gpts/`   
